import React from "react";

export default class PText extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      trainingSet: this.props.ts || [],
      probs: {},
      prediction: "",
      cursorIdx: 1,
      usrTxt: ""
    }
    this.train = this.train.bind(this);
    this.predict = this.predict.bind(this);
    this.handleTextInput = this.handleTextInput.bind(this);
  }

  componentDidMount() {
    this.state.trainingSet.unshift(null);
    this.state.trainingSet.push(null);
    this.state.trainingSet.push(null);
    this.train();
  }

  handleTextInput(e) {
    console.log(e.target.value, " ||| ", this.state.usrTxt);

    var newPrediction = this.predict(e.target.value, " ");
    if (e.target.value <= this.state.usrTxt) {
      console.log("should break");
      newPrediction = "";
      // if 
    }
    //if e.target.value === this.state.usrTxt
      //must have deleted suggestion
    //if e.target.value < this.state.usrTxt
      //must have deleted a bunch

    var $textarea = document.getElementById(this.props.id);
    //if key is not "backspace"
      //increment cursorIdx
    //else
      //decrement cursorIdx
      // this.setState({cursorIdx: this.state.cursorIdx+1})
      this.setState({usrTxt: e.target.value}, function() {
        if (newPrediction) {
          this.setState({prediction: newPrediction}, function() {
            $textarea.value = this.state.usrTxt+this.state.prediction;
            $textarea.selectionStart = this.state.usrTxt.length;
            $textarea.selectionEnd = $textarea.value.length+this.state.prediction.length;
          });
        }
      });
  }

  train() {
    var probabilities = {};
    this.state.trainingSet.forEach((glyph, idx) => {
      if (typeof glyph === "string") {
        glyph = glyph
          .split('')
          .map((el) => {
          return el === '.' ? '#' : el;
          })
          .join('')
      }
      var penult = this.state.trainingSet[idx-2] || '', 
      ult = this.state.trainingSet[idx-1] || '',
      key = [penult, ult, glyph].join('.'),
      target = this.state.trainingSet[idx+1] || '';
      
      //if triglyph does not already exist in probs, make it exist. 
      probabilities[key] = probabilities[key] ? probabilities[key] : {total: 0};
      probabilities[key].total++;
      //if triglyph does not have data for its current target, create that data
      probabilities[key][target] = probabilities[key][target] ? probabilities[key][target] : {total: 0};
      probabilities[key][target].total++;
      for (var targ in probabilities[key]) {
          if (targ !== "total") {
            probabilities[key][targ].prob = probabilities[key][targ].total / probabilities[key].total;  
            
          }
      }
    })
    this.setState({probs: probabilities});
  }

  predict(prev, breakAtChar) {
    if (prev.length < 3) {
      return false;
    }
    var currentTriGlyph = prev.slice(-3).split('').join('.') || '..',
    breaksAt = breakAtChar  || ' ',
    currentOutput = '',
    results = [];

     // this.setState({prediction: ""});

    while (currentOutput !== breaksAt) {
      // console.log("Current triglyph is: <<", currentTriGlyph, ">>")
      currentOutput = "";
      //generate random value.
      var roll = Math.random()*100;
        //use value to determine output glyph
      for (var poss in this.state.probs[currentTriGlyph]) {
        if (poss !== "total") {
            roll -= this.state.probs[currentTriGlyph][poss].prob * 100;  
        }
        // console.log(probabilities[currentTriGlyph][poss]);
        if (roll < 0) {
          currentOutput = poss;
          roll += 10000;
        }
      }
        if (typeof currentOutput === "string") {
          currentOutput = currentOutput
            .split('')
            .map((el) => {
            return el === '.' ? '#' : el;
            })
            .join('')
        }
        results.push(currentOutput);
      //update currentTriGlyph
      currentTriGlyph = currentTriGlyph.split(".");
      currentTriGlyph.shift();
      currentTriGlyph.push(currentOutput);
      currentTriGlyph = currentTriGlyph.join('.');
    }

    results = results
    .map((char) => {
      return (char === '#') ? '.' : char;
    })
    .join('');

    return results;
  }

  render() {
    return (
      <div>
        <textarea id={this.props.id} onChange={this.handleTextInput} />
      </div>
    );
  }
}